/*
  Copyright (C) 2002 Laurent Martelli <laurent@aopsys.com>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA */

package org.objectweb.jac.aspects.cache;

import org.objectweb.jac.core.AspectComponent;
import org.objectweb.jac.util.Log;


/**
 * This aspect handle caching of method results.
 */

public class CacheAC extends AspectComponent implements CacheConf {

   /**
    * Cache a method result.
    *
    * @param classExpr the classes
    * @param methodExpr the methods cached
    */
   public void cache(String classExpr, String methodExpr)
   {
      Log.trace("cache","cache "+classExpr+"."+methodExpr);

      pointcut("ALL",classExpr,methodExpr,
               "org.objectweb.jac.aspects.cache.CacheWrapper","cache",
               null,true);
   }
}

