/*
  Copyright (C) 2001-2002 Renaud Pawlak, Laurent Martelli
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

package org.objectweb.jac.aspects.gui;

import org.objectweb.jac.core.rtti.FieldItem;

/**
 * This interface represents viewers for field items. */

public interface FieldView extends View {
   /**
    * Sets the substance object holding the field
    * @param substance the substance
    */
   void setSubstance(Object substance);

   /**
    * Sets the value to display
    * @param value the value
    */
   void setValue(Object value);

   /**
    * Sets the field being displayed
    * @param field the field
    */
   void setField(FieldItem field);

   /**
    * @return the field item
    */
   FieldItem getField();

   /**
    * Sets the auto-update property of the view. If auto-update is
    * true (which is the default), the view registers for changes on
    * field it displays.
    */
   void setAutoUpdate(boolean autoUpdate);
}
