/*
  Copyright (C) 2002 Laurent Martelli <laurent@aopsys.com>
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA */

package org.objectweb.jac.aspects.gui.web;

import org.objectweb.jac.aspects.gui.*;
import org.objectweb.jac.util.Log;
import java.io.IOException;
import java.io.PrintWriter;

/**
 * An HTML page containing a View
 */
public abstract class AbstractPage extends AbstractView 
   implements HTMLViewer
{
   /* the view embedded in the page */
   protected View view;
   /* tells if the page is in a new window */
   boolean newWindow = false;

   public AbstractPage(View view, boolean newWindow) {
      super();
      view.setParentView(this);
      this.view = view;
      this.newWindow = newWindow;
   }

   public void close() {
      if (!newWindow) {
         Log.trace("web","closing "+this);
         super.close();
         view.close();
      } else {
         Log.trace("web","NOT closing "+this);
      }
   }

   // HTMLViewer interface

   public void genHTML(PrintWriter out) throws IOException {
      genPage(out);
   }

}
