<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">
<html>
  <head>
    <title>Demo</title>
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
    <link rel="stylesheet" type="text/css" href="basic.css" title="basic style">
  </head>
<body>

<?php
include "header.php";
require("menu.php"); 
menu("en","Demo");
?>

    <h1>Live Demonstration</h1>

    <p>A JAC server currently runs the photos sample on
      jac.aopsys.com. You can access the photo repository from the WEB
      and play with it.</p>

    <p>This sample uses the authentication and user aspects, so
      you'll have to enter a user and a password in order to be
      allowed to use it. In order to logg in as the administrator,
      use "admin" and "admin" as login and password. You will then
      be able to create new users: select the "users" entry from the
      "View" menu, and click on the add button.</p>

    <p>All users have a profile. The "Profiles" entry in the "View"
      menu allows the administrator to configure the rights granted
      to users of a profile. See the UserAC's documentation for more
      infos.</p>

    <p>We have created a "John Doe" user whose email is "john@doe.com"
      and whose password is "john". You can use this user if you do
      not want to create a new one.</p>

    <p>The default configuration allows the administrator to do
      anything. Users can view and add pictures, and the owner of a
      picture can modify it.</p>

    <p>Here is the link on the photos sample main window:<p>
      
    <p><a
	href="http://jac.aopsys.com/org/objectweb/jac/web">http://jac.aopsys.com/org/objectweb/jac/web</a>.</p>

    <p class=important>Please, do not upload big files, the server
      has a weak internet connection. And please, do not transform
      this demo into a porn site! Thank you.</p>
      
    <p>Following, the different aspect configurations for the sample
      (see the <code>src</code> directory of the <a
      href="downloads.html">JAC distribution</a> for the business
      model Java code).  As one can see, programming a JAC application
      is very simple and modular: each concern is customized in a
      declarative way. All the concerns put together give the gobal
      application's behavior.</p>

    <p>This is possible because JAC is an aspect-oriented application
      server. Each concerns is implemented in an aspect component that
      offers a configuration interface (see the links towards the API
      for each aspect component). Each method of the interface can be
      used in the configuration files.</p>

    <h2>Java source code</h2>

    <p>The sample photo application is composed of 5 business
    classes:</p>
    <ul>
      <li><a href="/demo/src/org/objectweb/jac/samples/photos/Photo.java.html">Photo.java</a></li>
      <li><a href="/demo/src/org/objectweb/jac/samples/photos/Person.java.html">Person.java</a></li>
      <li><a href="/demo/src/org/objectweb/jac/samples/photos/Comment.java.html">Comment.java</a></li>
      <li><a href="/demo/src/org/objectweb/jac/samples/photos/PhotoRepository.java.html">PhotoRepository.java</a></li>
      <li><a href="/demo/src/org/objectweb/jac/samples/photos/Users.java.html">Users.java</a></li>
    </ul>

    <p>As you can, these classes are trivial and do not contain any
      code for persistence, HTML, access rights, or any other
      aspect. All these concerns are treated by just plugin the
      appropriate aspect and configuring it. And of course, if you do
      not want an aspect, all you have to do is removing its line in
      .jac file!</p>

    <p>There's also the <code class=class>Run</code> class, which just
      creates an instance of <code class=class>PhotoRepository</code>
      and an instance of <code class=class>Users</code>:</p>

    <ul>
      <li><a href="/demo/src/org/objectweb/jac/samples/photos/Run.java.html">Run.java</a></li>
    </ul>

<h2>RTTI aspect configuration</h2>

<p>The RTTI aspect is used to add extra typing information on the
      business objects. Here, we specify that some field are textual
      (editable with multi-lines editors), date with hour, and
      password (content cannot be seen).</p>

<p>See the whole <a href="javadoc/org/objectweb/jac/core/rtti/RttiConf.html"
	target="Javadoc">configuration interface</a>.</p>

<pre class=code>
class  jac.samples.photos.Comment {
   setFieldType comment text;
   setFieldType date dateHour;
}

class jac.samples.photos.Person {
   setFieldType password password;
}
</pre>

<h2>GUI aspect configuration</h2>

<p>The GUI aspect is used to parametrize the rendering of the business
      classes so that they can be adequately displayed by the
      automatically generated GUI (can be Swing or WEB).</p>

<p>See the whole <a href="javadoc/org/objectweb/jac/aspects/gui/GuiConf.html"
	target="Javadoc">configuration interface</a>.</p>

<pre class=code>

defineResource ICON photo_icon "org/objectweb/jac/aspects/gui/resources/photo.png";

askForParameters "jac.samples.photos.*";

// Person
class jac.samples.photos.Person {
   setToString "%firstName% %lastName%";
   setMenu {setFirstName,setLastName,setEmail,setProfile};
   setAttributesOrder { firstName, lastName, profile, email, password, photos };
   setTableMembersOrder { firstName, lastName, profile, email };
   setCreationAttributesOrder { firstName, lastName, profile, email, password };
   setCollectionSortCriteria photos { title };
   attribute photos {
      setTableView;
      setAutoCreate;
      setMembersOrder jac.samples.photos.Photo {title,image};
   }
   attribute email {
      setEditorWidth 200 40;
   }
   attribute profile {
      setDynamicFieldChoice false 
		jac.samples.photos.PhotoRepository getProfiles;
   }
}

// Photo
class jac.samples.photos.Photo {
   setToString "%title%";
   setMenu {setTitle,setAuthor,setImage};
   setParameterNames "Photo(java.lang.String,jac.lib.Attachment)" 
                     { "title", "image" };
   setAttributesOrder {title,image,author,rate,date,comments};
   setCreationAttributesOrder {title,image};
   setTableMembersOrder {title,image,author};
   
   attribute rate {
      setFieldChoice "false" { 1, 2, 3, 4, 5, 0 };
   }
   setCategories { "main","comments" };
   attribute title,image,author,rate,date {
      setCategory "main";
   }
   attribute title {
      setEditorWidth 150 30;
   }
   attribute comments {
      setCategory "comments";
      setAutoCreate;
      setTableView;
   }
}

class jac.samples.photos.Comment {
   setToString "%text%";
   setCreationAttributesOrder { comment };
   setTableMembersOrder { date, author, comment };
   setEditorWidth comment 300 60;
}

// PhotoRepository
class jac.samples.photos.PhotoRepository {
   setParameterNames searchTitle(java.lang.String) { "string to search" };
   setAttributesOrder { photos };
   attribute photos {
      setTableView;
      setMembersOrder jac.samples.photos.Photo {title,image,author};
      setAutoCreate;
      setViewOnSelection;
      setNumRowsPerPage 4;
   }
}

class jac.samples.photos.Users {
   attribute users {
      setTableView;
      setAutoCreate;
      setViewOnSelection;
   }
}


// Specifying to the user that the username is his e-mail
class jac.aspects.authentication.PasswordAuthenticator {
   method askUsernameAndPassword {
      setParameterNames { "E-mail","Password" };
   }
}


// The GUI main window configuration
window main,web {
   registerCustomized;
   setTitle "Photos";
   
   menu "main" {
      addMenuItem { "View", "Photos" } jac.samples.photos.Run.viewPhotos { 0 };
      addMenuItem { "View", "Users" } jac.samples.photos.Run.viewUsers { 0 };
      addMenuItem { "View", "Profiles" } jac.aspects.user.UserAC.viewProfiles { 0 };
      addMenuItem { "Session", "Logout" } jac.aspects.gui.Actions.logout;
   }
}

window main {
   // The real simple GUI for swing
   setSubPanesGeometry 2 VERTICAL { false, false };
   setPaneContent 0 Object { photorepository0 };
   addReferenceToPane jac.samples.photos.PhotoRepository photos Object false "1";
   addReferenceToPane jac.aspects.user.UserManager profiles Object false "1";
   addReferenceToPane jac.samples.photos.Users users Object false "1";
   setPosition 0 0 80 80;
   setSplitterLocation 0 0.4;
   setOnCloseHandler jac.aspects.gui.Actions.exit;

}

class jac.samples.photos.Run {
   setIcon viewUsers users_icon;
   setIcon viewPhotos photo_icon;
}

window web {   
	// The real simple GUI for the web
   setSubPanesGeometry 1 NONE { false };
   setPaneContent 0 Object { photorepository0 };
   addReferenceToPane jac.samples.photos.PhotoRepository photos Object false "0";
   addReferenceToPane jac.samples.photos.Photo author Object false "0";
   addReferenceToPane jac.samples.photos.Person photos Object false "0";
   addReferenceToPane jac.samples.photos.Person profile Object false "0";
   addReferenceToPane jac.samples.photos.Users users Object false "0";
   addReferenceToPane jac.aspects.user.UserManager profiles Object false "0";
   menu "main" {
      setMenuPosition LEFT;
   }
   setNavBar jac.samples.photos.PhotoRepository photos;
}
</pre> 

<h2>Persistence aspect configuration</h2>

<p>The persistence aspect makes willed objects persistent in a
      storage. The storage can be on a file system or in a
      database.</p>

<p>See the whole <a
	href="javadoc/org/objectweb/jac/aspects/persistence/PersistenceConf.html"
	target="Javadoc">configuration interface</a>.</p>


<pre class=code>
configureStorage "jac.aspects.persistence.FSStorage" { "data/photos" };
makePersistent "jac.samples.photos.*" ALL;
registerStatics jac.samples.photos.PhotoRepository photorepository0;
registerStatics jac.samples.photos.Users users0;
</pre>

<h2>Authentication aspect configuration</h2>

<p>The authentication aspect is used to ensure that the user is
      identified regarding a users' list. This aspect can
      automatically open a popup to ask user's information.</p>

<p>See the whole <a href="javadoc/org/objectweb/jac/aspects/authentication/AuthenticationConf.html" target="Javadoc">configuration interface</a>.</p>

<pre class=code>
setAuthenticator 
	jac.aspects.authentication.UserPasswordAuthenticator 
	{"photos.user"};

setController jac.aspects.gui.*Display ".*showCustomized.* || fullRefresh.*" 
	jac.aspects.user.UserAC.userController;
setAccessDeniedMessage "Access not granted.";
</pre>

<h2>User aspect configuration</h2>

<p>The user aspect is used to define access rights of profiled
      users. It must be used with the authentication aspect.</p>

<p>See the whole <a href="javadoc/org/objectweb/jac/aspects/user/UserConf.html" target="Javadoc">configuration interface</a>.</p>

<pre class=code>
setUserClass jac.samples.photos.Person email password;
autoInitClasses jac.samples.photos.Photo 
   jac.samples.photos.PhotoRepository ADDERS(photos);
autoInitClasses jac.samples.photos.Comment;

defineAdministrator "admin" "admin";

profile "default" {
   declareProfile;
   addReadable "jac.aspects.gui.Actions.logout";
   addReadable "jac.samples.photos.Photo.*";
   addReadable "jac.samples.photos.Comment.*";
   addReadable "jac.samples.photos.Person.firstName";
   addReadable "jac.samples.photos.Person.lastName";
   addReadable "jac.samples.photos.Person.photos";
}

profile "user" {
   declareProfile "default";
   addReadable "jac.aspects.gui.Actions.*";
   addReadable "jac.samples.photos.Run.viewPhotos.*";
   addAddable "jac.samples.photos.PhotoRepository.photos";
   addAddable "jac.samples.photos.Photo.comments";
}

profile "owner" {
   declareProfile;
   addWritable "jac.samples.photos.Photo.*";
   addWritable "jac.samples.photos.Comment.comment";
}
</pre>

<h2>Confirmation aspect configuration</h2>

<p>This aspect asks for the users confirmation before actually
      proceeding given actions (here, the collection removing).</p>

<p>See the whole <a href="javadoc/org/objectweb/jac/aspects/confirmation/ConfirmationConf.html" target="Javadoc">configuration interface</a>.</p>

<pre class=code>
confirm jac.samples.photos.PhotoRepository REMOVERS ALL;
confirm jac.samples.photos.Photo REMOVERS ALL;
</pre>

<h2>Integrity aspect configuration</h2>

<p>This aspect is used to ensure the application's data integrity.</p>

<p>See the whole <a href="javadoc/org/objectweb/jac/aspects/integrity/IntegrityConf.html" target="Javadoc">configuration interface</a>.</p>

<pre class=code>
declareAssociation 
	jac.samples.photos.Person photos
	jac.samples.photos.Photo author;

declareAssociation 
	jac.samples.photos.Comment photo
	jac.samples.photos.Photo comments;

updateOppositeRoles jac.samples.photos.*;

declareRepository users0 jac.samples.photos.Users.users 
	jac.samples.photos.Photo.author;

declareConstraint jac.samples.photos.Photo author 
   jac.samples.photos.Users.users FORBIDDEN;
declareConstraint jac.samples.photos.Comment author 
   jac.samples.photos.Users.users SET_NULL;
declareConstraint jac.samples.photos.Comment photo 
   jac.samples.photos.Users.users DELETE_CASCADE;
</pre>

<h2>Session aspect configuration</h2>

<p>The session aspect ensures that a session id is set in the context
      and that contextual attributes are saved and restored for each
      session. Here, we restore the <code>Authentication.user</code>
      contextual attribute in order to avoid user's authentication on
      each client's interaction.</p>

<p>See the whole <a href="javadoc/org/objectweb/jac/aspects/session/SessionConf.html" target="Javadoc">configuration interface</a>.</p>

<pre class=code>
defineSessionHandlers "jac.samples.photos.*" ".*" ".*";
declareStoredAttributes {"Authentication.user"};
</pre>

<h2>Cache aspect configuration</h2>

<p>This aspect allows some methods' results to be cached (they are only
    calculated once). Here, the <code>createThumbArray</code> method
    that calculates the photos thumbnails can be quite long and we
    prefer to cache its result.</p>

<p>See the whole <a href="javadoc/org/objectweb/jac/aspects/cache/CacheConf.html" target="Javadoc">configuration interface</a>.</p>

<pre class=code>
cache jac.util.Thumbnail "createThumbArray.*";
</pre>

    <div class=footer>      
      JAC is an Open Source software developped by the <a
      href="http://www.aopsys.com">AOPSYS</a> (TM) company with the
      collaboration of the <a href="http://www.lip6.fr">LIP6</a>,
      the <a href="http://cedric.cnam.fr">CEDRIC</a>, and the <a href="http://www.lifl.fr">LIFL</a> laboratories.<br> JAC is a direct
      application of the <a
      href="http://cedric.cnam.fr/~pawlak">Renaud Pawlak</a>'s PhD
      Thesis.
    </div>

</body>
</html>

<--
Local Variables:
mode: sgml
End:
!-->
