<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">
<html>
  <head>
    <title>Publications</title>
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
    <link rel="stylesheet" type="text/css" href="basic.css" title="basic style">
  </head>
<body>

<?php
include "header.php";
require("menu.php"); 
menu("en","Publications");
?>

    <h1>Publications</h1>

	<p><i>Note: since JAC is rapidly evolving, publications may
	refer to prior releases and present small differences with the
	actual framework. However, the underlying ideas are
	stable.</i></p>

    <hr>

      <p><a href="papers/these_pawlak.tgz">Interactionnal
      Aspect-Oriented Programming to Construct Multi-Concerns
      Applications.</a><br>Renaud Pawlak.<br> PhD Thesis. 220
      pages. December 2002.<br>
      (In French for the state of the art and theorical parts,
      in English for the JAC part).</p>

    <hr>

      <p>JAC: A Flexible Framework for AOP in Java.<br>
      Renaud Pawlak, Lionel Seinturier, Laurence Duchien, Grard
      Florin, <a
      href="http://www.openjit.org/reflection2001/">Reflection'01</a>,
      Kyoto, Japan. <a href="papers/reflection.ps">PS</a> <a href="papers/reflection.ps.gz">PS.gz</a></p>

    <p class=abstract><b>Abstract</b>: <i>This paper presents some
      recurent issues that arise when programming aspect-oriented
      applications and shows how the JAC core mecanisms solve these
      issues. It presents an aspect-composer that is able to group
      composition rules that usually crosscut all the aspects.</i></p>

    <hr>

    <p>Dynamic wrappers: handling the composition issue with JAC<br>
     Renaud Pawlak, Lionel Seinturier, Laurence Duchien, Grard
      Florin, <a
      href="http://www.tools-conferences.com/tools/usa/">TOOLS
      2001</a>, Santa-Barbara CA, USA. <a href="papers/pawlak_tools01.ps">PS</a> <a href="papers/pawlak_tools01.ps.gz">PS.gz</a>
	  
    <p class=abstract><b>Abstract</b>: <i>Modern applications, and
      especially distributed ones, most of the time need exibility and
      dynamic evolution. These goals can be partially reached with
      separation of concerns. However, a static approach is not
      sufficient when trying to get dynamic adaptation during the
      application execution-time. In this paper, we present the JAC
      framework that meets dynamic adaptation by using the notions of
      dynamic wrappers in order to achieve separation of concerns for
      non-functional programs, and of wrapping controllers to
      implement the composition of wrappers (maybe coming from
      different programmers) at wrap-time and at call-time.</i>

      <hr>

    <p><a href="http://www.lip6.fr/reports/lip6.2001.025.html">JAC Milestone 2001</a><br>
      L. Seinturier, R. Pawlak, L. Duchien, G. Florin<br>
      LIP6 research reports, 29 pages - Novembre/November 2001

    <p class=abstract><b>Abstract</b>: <i>JAC (Java Aspect Components)
	is a framework for aspect-oriented programming in Java. It is
	developed as a joint research project between the CEDRIC-CNAM
	and LIP6 computer science laboratories. This report gives a
	snapshot of the project as of September 2001.  Unlike
	languages such as AspectJ which are mostly class-based, JAC is
	object-based and does not require any language extensions to
	Java. It uses the Javassist class load-time MOP. An aspect
	program in JAC is a set of aspect objects that can be
	dynamically deployed and undeployed on top of running
	application objects. Aspect objects may define three kinds of
	aspect methods: wrapping methods (that wrap application
	methods and provide the ability to run code before and after
	the wrapped methods), role methods (that add new
	functionalities to application objects), and exception
	handlers. The aspects composition issue is handled through a
	well-defined wrapping controller that specifies for each
	wrapped object at wrap-time, runtime or both, the execution
	order of aspect objects.</i></p>

      <hr>

    <p><a href="papers/uml_short/uml.html" target="uml">A position
      paper on AOP modeling in UML</a>, presented at the <a
      href="http://lglwww.epfl.ch/workshops/aosd-uml/index.html">AO
      modeling with UML workshop at the AOSD 2002 conference</a></p>

    <p>Here is a <a href="papers/uml/uml.html" target="uml">longer
    version</a>.</p>

    <h1><img class=flag alt="French" src="images/french_flag.gif">En Franais... (In French...)</h1>

      <p>Prsentation du groupe CAOLAC et de JAC. Journe PRO 2001,
      Toulouse (in French). <a href="papers/cedric.pdf">PDF</a> <a
      href="papers/cedric.pdf.gz">PDF.gz</a></p>

      <hr>

    <p>Le 01/04/2002, le magazine <a
	href="http://www.devreference.net">Dveloppeur
	Rfrence</a> publie un article consacr  JAC.
      <br><a
	href="http://www.aopsys.com/devrefv210p11-13.pdf">Le
	consulter (format pdf)</a>

    <hr>

    <p>Article dans la revue "L'Objet",  paratre.<p>

    <hr>

      <p><a href="papers/these_pawlak.tgz">La Programmation par Aspects
      Interactionnelle pour la Construction d'Applications 
      Proccupations Multiples.</a><br> Renaud Pawlak.<br> Thse de
      Doctorat. 220 pages. Decembre 2002.<br>(En franais
      pour les parties tat de l'art + thorie, en anglais pour la
      partie JAC).</p>

    <hr>

<?php require("footer.php"); footer(false); ?>

  </body>
</html>
